﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Diagnostics;
using System.Threading;

namespace TasksAndWinForms {
	public partial class Form1 : Form {
		public Form1() {
			InitializeComponent();
		}

		private void button1_Click(object sender, EventArgs e) {
			Debug.Print("--------");
			Debug.Print("button1_Click: TID == {0}: begin", Thread.CurrentThread.ManagedThreadId);

			var t1 = Task.Run(() => {
				Debug.Print("Task t1: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
			
				var t2 = Task.Run(() => {
					Debug.Print("Task t2: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
					Thread.Sleep(500);
					Debug.Print("Task t2: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
				});
				Thread.Sleep(500);
				Debug.Print("Task t1: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
			});

			Thread.Sleep(100);

			Debug.Print("button1_Click: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
		}

		private void button2_Click(object sender, EventArgs e) {
			Debug.Print("--------");
			Debug.Print("button2_Click: TID == {0}: begin", Thread.CurrentThread.ManagedThreadId);

			var sched = TaskScheduler.FromCurrentSynchronizationContext();
			var t1 = Task.Run(() => {
				Debug.Print("Task t1: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);

				var t2 = Task.Factory.StartNew(() => {
					Debug.Print("  Task t2: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);

					var t3 = Task.Factory.StartNew(() => {
						Debug.Print("  + Task t3: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  + Task t3: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					});
					var t4 = Task.Run(() => {
						Debug.Print("  - Task t4: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  - Task t4: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					});
					var t5 = Task.Factory.StartNew(() => {
						Debug.Print("  * Task t5: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  * Task t5: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					}, TaskCreationOptions.HideScheduler);  // Will behave in the same way as t3 - as HideScheduler hides scheduler from children

					Thread.Sleep(1000);
					Debug.Print("Task t2: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
				}, CancellationToken.None, TaskCreationOptions.None, sched);

				// t2.Wait();
				Thread.Sleep(1000);
				Debug.Print("Task t1: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
			});

			Thread.Sleep(100);

			Debug.Print("button2_Click: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
		}

		private void button3_Click(object sender, EventArgs e) {
			Debug.Print("--------");
			Debug.Print("button3_Click: TID == {0}: begin", Thread.CurrentThread.ManagedThreadId);

			var sched = TaskScheduler.FromCurrentSynchronizationContext();
			var t1 = Task.Run(() => {
				Debug.Print("Task t1: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);

				var t2 = Task.Factory.StartNew(() => {
					Debug.Print("  Task t2: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);

					var t3 = Task.Factory.StartNew(() => {
						Debug.Print("  + Task t3: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  + Task t3: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					});
					var t4 = Task.Run(() => {
						Debug.Print("  - Task t4: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  - Task t4: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					});
					var t5 = Task.Factory.StartNew(() => {
						Debug.Print("  * Task t5: TID == {0}: start", Thread.CurrentThread.ManagedThreadId);
						Thread.Sleep(500);
						Debug.Print("  * Task t5: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
					}, TaskCreationOptions.HideScheduler);	// Will behave in the same way as t3 - as HideScheduler hides scheduler from children

					Thread.Sleep(1000);
					Debug.Print("Task t2: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
				}, CancellationToken.None, TaskCreationOptions.HideScheduler, sched);   // Now t3, nor t5 will not see our custom scheduler.
																						// i.e. TaskScheduler.Current will return TaskScheduler.Default even if the current Task is running inside non-default scheduler.

				// t2.Wait();
				Thread.Sleep(1000);
				Debug.Print("Task t1: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
			});

			Thread.Sleep(100);

			Debug.Print("button3_Click: TID == {0}: end", Thread.CurrentThread.ManagedThreadId);
		}
	}
}
